﻿using C1.Win.FlexReport;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace DynamicColumns
{
    public partial class Form1 : Form
    {
        //Text Fields
        Field tbTitle, tbDebit, tbCredit, tbNumber, tbName, tbSiteHeader, tbNameCaption, tbNumberCaption, tbDebitCaption, tbCreditCaption;
        int sitenumber;

        public Form1()
        {
            InitializeComponent();
        }

        private void cmbNoOfSites_SelectedIndexChanged(object sender, EventArgs e)
        {
            //Number of Columns to Show
            sitenumber = int.Parse(cmbNoOfSites.SelectedItem.ToString());
            string sitequery = "";
            for (int i = 1; i < sitenumber + 1; i++)
            {
                //Fetching only desired columns from Database
                sitequery = sitequery + "Site" + i.ToString() + "Credit , Site" + i.ToString() + "Debit, "; 
            }
            string sqlString = "Select BranchID, BranchName, " + sitequery;
            sqlString = sqlString.Remove(sqlString.Length - 2, 1);
            sqlString += " FROM rptDB";

            CreateReport();
            c1FlexReport1.Layout.PaperSize = System.Drawing.Printing.PaperKind.A3;
            c1FlexReport1.Layout.Orientation = OrientationEnum.Landscape;

            //Assigning DataSource
            c1FlexReport1.DataSource.ConnectionString = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + Application.StartupPath + @"\..\..\FlexrptDB.mdb;Persist Security Info=False";
            c1FlexReport1.DataSource.RecordSource = sqlString;
            c1FlexReport1.DataSource.DataProvider = DataProvider.OLEDB;
            c1FlexViewer1.DocumentSource = c1FlexReport1;
        }

        //Creating Report layout according to number of dynamic Columns
        private void CreateReport()
        {
            c1FlexReport1.Clear();

            //Height(landscape) of a A3 Page
            c1FlexReport1.Layout.Width = 16.53 * 1440;

            // create a report header    
            Section sHeader = c1FlexReport1.Sections[SectionTypeEnum.Header];
            sHeader.Height = 1.5*1440;
            sHeader.Visible = true;

            //Title Field
            tbTitle = new Field();
            tbTitle.Name = "FldTitle";
            tbTitle.Text = "Dynamic Report";
            tbTitle.Left = 0;
            tbTitle.Top = 0;
            tbTitle.BackColor = Color.LightCyan;
            tbTitle.Width = c1FlexReport1.Layout.Width - c1FlexReport1.Layout.MarginRight - c1FlexReport1.Layout.MarginLeft;
            tbTitle.Height = 1440;
            tbTitle.Align = FieldAlignEnum.CenterMiddle;
            tbTitle.Font.Size = 25f;
            tbTitle.Font.Bold = true;
            tbTitle.ForeColor = Color.FromArgb(0, 0, 100);
            sHeader.Fields.Add(tbTitle);

            if (sitenumber > 0)
            {
                // create a page footer
                Section sPageHeader = c1FlexReport1.Sections[SectionTypeEnum.PageHeader];
                sPageHeader.Height = 0.65*1440;
                sPageHeader.Visible = true;

                tbNumberCaption = new Field();
                tbNumberCaption.Name = "tbNumberCaption";
                tbNumberCaption.Text = "Num";
                tbNumberCaption.BackColor = Color.FromArgb(200, 200, 200);
                tbNumberCaption.Left = 0;
                tbNumberCaption.Top = 0.3 * 1440;
                tbNumberCaption.Width = 0.8 * 1440;
                tbNumberCaption.Height = 0.3 * 1440;
                tbNumberCaption.Align = FieldAlignEnum.CenterMiddle;
                tbNumberCaption.Border = new C1.Win.C1Document.Border(30f, Color.Black, C1.Win.C1Document.DashStyle.Solid);
                tbNumberCaption.Font.Size = 15f;
                tbNumberCaption.Font.Bold = true;
                sPageHeader.Fields.Add(tbNumberCaption);

                tbNameCaption = new Field();
                tbNameCaption.Name = "tbNameCaption";
                tbNameCaption.Text = "Name";
                tbNameCaption.BackColor = Color.FromArgb(200, 200, 200);
                tbNameCaption.Left = 0.8 * 1440;
                tbNameCaption.Top = 0.3 * 1440;
                tbNameCaption.Width = 0.8 * 1440;
                tbNameCaption.Height = 0.3 * 1440;
                tbNameCaption.Align = FieldAlignEnum.CenterMiddle;
                tbNameCaption.Border = new C1.Win.C1Document.Border(30f, Color.Black, C1.Win.C1Document.DashStyle.Solid);
                tbNameCaption.Font.Size = 15f;
                tbNameCaption.Font.Bold = true;
                sPageHeader.Fields.Add(tbNameCaption);

                //Calculating the available width to decide Column's Width
                double GrosspageWidth = c1FlexReport1.Layout.Width - tbNameCaption.Width - tbNumberCaption.Width - c1FlexReport1.Layout.MarginLeft - c1FlexReport1.Layout.MarginRight;
                double fieldWidth = GrosspageWidth / (sitenumber * 2);

                Section sDetail = c1FlexReport1.Sections[SectionTypeEnum.Detail];
                sDetail.Height = 0.4 * 1440;
                sDetail.AutoHeight = AutoSizeBehavior.GrowAndShrink;
                sDetail.Visible = true;

                tbNumber = new Field();
                tbNumber.Name = "tbNumber";
                tbNumber.Text = "BranchID";
                tbNumber.Calculated = true;
                tbNumber.Left = 0;
                tbNumber.Top = 0;
                tbNumber.Width = 0.8 * 1440;
                tbNumber.Height = 0.4 * 1440;
                tbNumber.Align = FieldAlignEnum.CenterMiddle;
                tbNumber.Border = new C1.Win.C1Document.Border(15f, Color.Black, C1.Win.C1Document.DashStyle.Solid);
                tbNumber.Font.Size = 12f;
                sDetail.Fields.Add(tbNumber);

                tbName = new Field();
                tbName.Name = "tbName";
                tbName.Text = "BranchName";
                tbName.Calculated = true;
                tbName.Left = 0.8 * 1440;
                tbName.Top = 0;
                tbName.Width = 0.8 * 1440;
                tbName.Height = 0.4 * 1440;
                tbName.Align = FieldAlignEnum.CenterMiddle;
                tbName.Border = new C1.Win.C1Document.Border(15f, Color.Black, C1.Win.C1Document.DashStyle.Solid);
                tbName.Font.Size = 12f;
                sDetail.Fields.Add(tbName);

                for (int i = 1; i <= sitenumber; i++)
                {
                    //Dynamic Column Captions
                    tbSiteHeader = new Field();
                    tbSiteHeader.Name = "SiteHeader" + (i).ToString();
                    tbSiteHeader.Text = "Site" + (i).ToString();
                    tbSiteHeader.BackColor = Color.FromArgb(200, 200, 200);
                    tbSiteHeader.Left = tbNumberCaption.Width + tbNameCaption.Width + (fieldWidth * (i - 1) * 2);
                    tbSiteHeader.Top = 0;
                    tbSiteHeader.Width = fieldWidth * 2;
                    tbSiteHeader.Height = 0.3f * 1440;
                    tbSiteHeader.Align = FieldAlignEnum.CenterMiddle;
                    tbSiteHeader.Border = new C1.Win.C1Document.Border(30f, Color.Black, C1.Win.C1Document.DashStyle.Solid);
                    tbSiteHeader.Font.Size = 15f;
                    tbSiteHeader.Font.Bold = true;
                    sPageHeader.Fields.Add(tbSiteHeader);

                    tbDebitCaption = new Field();
                    tbDebitCaption.Name = "Site" + (i).ToString() + "DebitCaption";
                    tbDebitCaption.Text = "Debit";
                    tbDebitCaption.BackColor = Color.FromArgb(200, 200, 200);
                    tbDebitCaption.Left = tbNumberCaption.Width + tbNameCaption.Width + (fieldWidth * (i - 1) * 2);
                    tbDebitCaption.Top = 0.3 * 1440;
                    tbDebitCaption.Width = fieldWidth;
                    tbDebitCaption.Height = 0.3f * 1440;
                    tbDebitCaption.Align = FieldAlignEnum.CenterMiddle;
                    tbDebitCaption.Border = new C1.Win.C1Document.Border(30f, Color.Black, C1.Win.C1Document.DashStyle.Solid);
                    tbDebitCaption.Font.Size = 15f;
                    tbDebitCaption.Font.Bold = true;
                    sPageHeader.Fields.Add(tbDebitCaption);

                    tbCreditCaption = new Field();
                    tbCreditCaption.Name = "Site" + (i).ToString() + "CreditCaption";
                    tbCreditCaption.Text = "Credit";
                    tbCreditCaption.BackColor = Color.FromArgb(200, 200, 200);
                    tbCreditCaption.Left = tbNumberCaption.Width + tbNameCaption.Width + (fieldWidth * (i - 1) * 2) + fieldWidth;
                    tbCreditCaption.Top = 0.3 * 1440;
                    tbCreditCaption.Width = fieldWidth;
                    tbCreditCaption.Height = 0.3f * 1440;
                    tbCreditCaption.Align = FieldAlignEnum.CenterMiddle;
                    tbCreditCaption.Border = new C1.Win.C1Document.Border(30f, Color.Black, C1.Win.C1Document.DashStyle.Solid);
                    tbCreditCaption.Font.Size = 15f;
                    tbCreditCaption.Font.Bold = true;
                    sPageHeader.Fields.Add(tbCreditCaption);

                    //Dynamic Columns
                    tbDebit = new Field();
                    tbDebit.Name = "Site" + (i).ToString() + "Debit";
                    tbDebit.Text = "Site" + i.ToString() + "Debit";
                    tbDebit.Left = tbNumberCaption.Width + tbNameCaption.Width + (fieldWidth * (i - 1) * 2);
                    tbDebit.Top = 0;
                    tbDebit.Width = fieldWidth;
                    tbDebit.Height = 0.4f * 1440;
                    tbDebit.Calculated = true;
                    tbDebit.Align = FieldAlignEnum.CenterMiddle;
                    tbDebit.Border = new C1.Win.C1Document.Border(15f, Color.Black, C1.Win.C1Document.DashStyle.Solid);
                    tbDebit.Font.Size = 12f;
                    sDetail.Fields.Add(tbDebit);

                    tbCredit = new Field();
                    tbCredit.Name = "Site" + (i).ToString() + "Debit";
                    tbCredit.Text = "Site" + (i).ToString() + "Credit";
                    tbCredit.Left = tbNumberCaption.Width + tbNameCaption.Width + (fieldWidth * (i - 1) * 2) + fieldWidth;
                    tbCredit.Top = 0;
                    tbCredit.Width = fieldWidth;
                    tbCredit.Height = 0.4f * 1440;
                    tbCredit.Calculated = true;
                    tbCredit.Align = FieldAlignEnum.CenterMiddle;
                    tbCredit.Border = new C1.Win.C1Document.Border(15f, Color.Black, C1.Win.C1Document.DashStyle.Solid);
                    tbCredit.Font.Size = 12f;
                    sDetail.Fields.Add(tbCredit);
                }
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            cmbNoOfSites.SelectedIndex = 0;
        }
    }
}
